/*
 * JBoss, Home of Professional Open Source.
 *
 * See the LEGAL.txt file distributed with this work for information regarding copyright ownership and licensing.
 *
 * See the AUTHORS.txt file distributed with this work for a full listing of individual contributors.
 */
package org.teiid.designer.metamodels.transformation;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Input Parameter</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.teiid.designer.metamodels.transformation.InputParameter#getName <em>Name</em>}</li>
 * <li>{@link org.teiid.designer.metamodels.transformation.InputParameter#getInputSet <em>Input Set</em>}</li>
 * <li>{@link org.teiid.designer.metamodels.transformation.InputParameter#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.teiid.designer.metamodels.transformation.TransformationPackage#getInputParameter()
 * @model
 * @generated
 *
 * @since 8.0
 */
public interface InputParameter extends EObject {

    /**
     * Returns the value of the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Name</em>' attribute.
     * @see #setName(String)
     * @see org.teiid.designer.metamodels.transformation.TransformationPackage#getInputParameter_Name()
     * @model
     * @generated
     */
    String getName();

    /**
     * Sets the value of the '{@link org.teiid.designer.metamodels.transformation.InputParameter#getName <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Name</em>' attribute.
     * @see #getName()
     * @generated
     */
    void setName( String value );

    /**
     * Returns the value of the '<em><b>Input Set</b></em>' container reference. It is bidirectional and its opposite is '
     * {@link org.teiid.designer.metamodels.transformation.InputSet#getInputParameters <em>Input Parameters</em>}'. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Input Set</em>' container reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Input Set</em>' container reference.
     * @see #setInputSet(InputSet)
     * @see org.teiid.designer.metamodels.transformation.TransformationPackage#getInputParameter_InputSet()
     * @see org.teiid.designer.metamodels.transformation.InputSet#getInputParameters
     * @model opposite="inputParameters" required="true"
     * @generated
     */
    InputSet getInputSet();

    /**
     * Sets the value of the '{@link org.teiid.designer.metamodels.transformation.InputParameter#getInputSet <em>Input Set</em>}'
     * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Input Set</em>' container reference.
     * @see #getInputSet()
     * @generated
     */
    void setInputSet( InputSet value );

    /**
     * Returns the value of the '<em><b>Type</b></em>' reference. <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Type</em>' reference isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Type</em>' reference.
     * @see #setType(EObject)
     * @see org.teiid.designer.metamodels.transformation.TransformationPackage#getInputParameter_Type()
     * @model required="true"
     * @generated
     */
    EObject getType();

    /**
     * Sets the value of the '{@link org.teiid.designer.metamodels.transformation.InputParameter#getType <em>Type</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Type</em>' reference.
     * @see #getType()
     * @generated
     */
    void setType( EObject value );

} // InputParameter
